diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 67f0580cc..69c088d56 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -1,9 +1,11 @@
 package net.minecraft.server.net;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.net.handler.LoginPacketHandler;
@@ -17,23 +19,24 @@ import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.save.PlayerIO;
 import net.minecraft.server.MinecraftServer;
-import org.apache.log4j.Logger;
+import org.slf4j.Logger;
 import org.jetbrains.annotations.Nullable;
 
 
 import java.io.*;
 import java.util.*;
+import java.util.concurrent.atomic.AtomicInteger;
 
 public class PlayerList
 {
-    public static Logger logger = Logger.getLogger("Minecraft");
+    public static Logger logger = LogUtils.getLogger();
     public List<ServerPlayer> playerEntities;
     private final MinecraftServer server;
     private final PlayerManager[] playerManagers;
-    private final Set<String> bans;
+    private final Set<UUID> bans;
     private final Set<String> ipBans;
-    private final Set<String> ops;
-    private final Set<String> whitelist;
+    private final Set<UUID> ops;
+    private final Set<UUID> whitelist;
     private final File bansFile;
     private final File ipBansFile;
     private final File opsFile;
@@ -41,6 +44,8 @@ public class PlayerList
     private PlayerIO playerIo;
     private final boolean whitelistEnforced;
 
+    AtomicInteger awaitedLoadThreads = new AtomicInteger(0);
+
     public PlayerList(MinecraftServer server)
     {
         playerEntities = new ArrayList<>();
@@ -60,14 +65,41 @@ public class PlayerList
             playerManagers[dim] = new PlayerManager(server, dim, viewDistance);
         }
         whitelistEnforced = server.propertyManager.getBooleanProperty("white-list", false);
-        readBannedPlayers();
+        loadBannedPlayers();
         loadBannedList();
         loadOps();
         loadWhiteList();
-        writeBannedPlayers();
+        saveBannedPlayers();
         saveBannedList();
         saveOps();
         saveWhiteList();
+
+        // If there's still some threads converting usernames to UUIDs then wait for them all to finish before saving their results to file
+        if (awaitedLoadThreads.get() > 0) {
+            new Thread( () ->
+                {
+                    long startTime = System.currentTimeMillis();
+                    while (awaitedLoadThreads.get() > 0) {
+                        try {
+                            Thread.sleep(100);
+                        } catch (InterruptedException e) {
+                            e.printStackTrace();
+                            break;
+                        }
+                        if (System.currentTimeMillis() - startTime > 600_000) break;
+                    }
+                    try {
+                        Thread.sleep(1000);
+                    } catch (InterruptedException e) {
+                        e.printStackTrace();
+                    }
+                    saveBannedPlayers();
+                    saveBannedList();
+                    saveOps();
+                    saveWhiteList();
+                }
+            ).start();
+        }
     }
 
     public void setPlayerManager(WorldServer[] aworldserver)
@@ -132,14 +164,14 @@ public class PlayerList
         getPlayerManager(entityplayermp.dimension).removePlayer(entityplayermp);
     }
 
-    public ServerPlayer getPlayerForLogin(LoginPacketHandler handler, String username)
+    public ServerPlayer getPlayerForLogin(LoginPacketHandler handler, String username, UUID uuid)
     {
-        if (bans.contains(username.trim().toLowerCase()))
+        if (bans.contains(uuid))
         {
             handler.kickUser("You are banned from this server!");
             return null;
         }
-        if (!isAllowedToLogin(username))
+        if (!isAllowedToLogin(uuid))
         {
             handler.kickUser("You are not white-listed on this server!");
             return null;
@@ -157,16 +189,13 @@ public class PlayerList
             handler.kickUser("The server is full!");
             return null;
         }
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            ServerPlayer player = playerEntities.get(i);
-            if (player.username.equalsIgnoreCase(username))
-            {
+        for (ServerPlayer player : playerEntities) {
+            if (player.username.equalsIgnoreCase(username) || player.uuid.equals(uuid)) {
                 player.playerNetServerHandler.kickPlayer("You are logged in from another location!");
             }
         }
 
-        return new ServerPlayer(server, server.getDimensionWorld(0), username, new ServerPlayerController(server.getDimensionWorld(0)));
+        return new ServerPlayer(server, server.getDimensionWorld(0), username, uuid, new ServerPlayerController(server.getDimensionWorld(0)));
     }
 
     public ServerPlayer recreatePlayerEntity(ServerPlayer previousPlayer, int i)
@@ -178,7 +207,7 @@ public class PlayerList
         server.getDimensionWorld(previousPlayer.dimension).removePlayer(previousPlayer);
         ChunkCoordinates chunkcoordinates = previousPlayer.getPlayerSpawnCoordinate();
         previousPlayer.dimension = i;
-        ServerPlayer newPlayer = new ServerPlayer(server, server.getDimensionWorld(previousPlayer.dimension), previousPlayer.username, new ServerPlayerController(server.getDimensionWorld(previousPlayer.dimension)));
+        ServerPlayer newPlayer = new ServerPlayer(server, server.getDimensionWorld(previousPlayer.dimension), previousPlayer.username, previousPlayer.uuid, new ServerPlayerController(server.getDimensionWorld(previousPlayer.dimension)));
         newPlayer.id = previousPlayer.id;
         newPlayer.chatColor = previousPlayer.chatColor;
         newPlayer.nickname = previousPlayer.nickname;
@@ -273,11 +302,9 @@ public class PlayerList
 
     public void onTick()
     {
-        for (int i = 0; i < playerManagers.length; i++)
-        {
-            playerManagers[i].tick();
+        for (PlayerManager playerManager : playerManagers) {
+            playerManager.tick();
         }
-
     }
 
     public void markBlockNeedsUpdate(int i, int j, int k, int l)
@@ -287,73 +314,73 @@ public class PlayerList
 
     public void sendPacketToAllPlayers(Packet packet)
     {
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            ServerPlayer entityplayermp = playerEntities.get(i);
-            entityplayermp.playerNetServerHandler.sendPacket(packet);
+        for (ServerPlayer player : playerEntities) {
+            player.playerNetServerHandler.sendPacket(packet);
         }
 
     }
 
     public void sendEncryptedChatToAllPlayers(String message)
     {
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            ServerPlayer entityplayermp = playerEntities.get(i);
-            entityplayermp.playerNetServerHandler.sendPacket(new ChatPacket(message, 0, AES.keyChain.get(entityplayermp.username)));
+        for (ServerPlayer player : playerEntities) {
+            player.playerNetServerHandler.sendPacket(new ChatPacket(message, 0, AES.keyChain.get(player.username)));
         }
 
     }
 
     public void sendPacketToAllPlayersInDimension(Packet packet, int i)
     {
-        for (int j = 0; j < playerEntities.size(); j++)
-        {
-            ServerPlayer entityplayermp = playerEntities.get(j);
-            if (entityplayermp.dimension == i)
-            {
-                entityplayermp.playerNetServerHandler.sendPacket(packet);
+        for (ServerPlayer player : playerEntities) {
+            if (player.dimension == i) {
+                player.playerNetServerHandler.sendPacket(packet);
             }
         }
-
     }
 
     public String getPlayerList()
     {
-        String s = "";
+        StringBuilder s = new StringBuilder();
         for (int i = 0; i < playerEntities.size(); i++)
         {
             if (i > 0)
             {
-                s = s + ", ";
+                s.append(", ");
             }
-            s = s + playerEntities.get(i).getDisplayName();
+            s.append(playerEntities.get(i).getDisplayName());
         }
 
-        return s;
+        return s.toString();
     }
 
-    public void banPlayer(String s)
+    public synchronized void banPlayer(UUID uuid)
     {
-        bans.add(s.toLowerCase());
-        writeBannedPlayers();
+        bans.add(uuid);
+        saveBannedPlayers();
     }
 
-    public void pardonPlayer(String s)
+    public synchronized void pardonPlayer(UUID uuid)
     {
-        bans.remove(s.toLowerCase());
-        writeBannedPlayers();
+        bans.remove(uuid);
+        saveBannedPlayers();
     }
 
-    private void readBannedPlayers()
+    private synchronized void loadBannedPlayers()
     {
         try
         {
             bans.clear();
             BufferedReader bufferedreader = new BufferedReader(new FileReader(bansFile));
-            for (String s = ""; (s = bufferedreader.readLine()) != null; )
+            for (String s; (s = bufferedreader.readLine()) != null; )
             {
-                bans.add(s.trim().toLowerCase());
+                if (!UUIDHelper.isUUID(s)) {
+                    awaitedLoadThreads.addAndGet(1);
+                    UUIDHelper.runConversionAction(s, uuid -> {
+                        bans.add(uuid);
+                        awaitedLoadThreads.addAndGet(-1);
+                    }, (username) -> awaitedLoadThreads.addAndGet(-1));
+                } else {
+                    bans.add(UUID.fromString(s));
+                }
             }
 
             bufferedreader.close();
@@ -364,15 +391,15 @@ public class PlayerList
         }
     }
 
-    private void writeBannedPlayers()
+    private synchronized void saveBannedPlayers()
     {
         try
         {
             PrintWriter printwriter = new PrintWriter(new FileWriter(bansFile, false));
-            String s;
-            for (Iterator iterator = bans.iterator(); iterator.hasNext(); printwriter.println(s))
+            UUID uuid;
+            for (Iterator<UUID> iterator = bans.iterator(); iterator.hasNext(); printwriter.println(uuid))
             {
-                s = (String) iterator.next();
+                uuid = iterator.next();
             }
 
             printwriter.close();
@@ -383,27 +410,27 @@ public class PlayerList
         }
     }
 
-    public void banIP(String s)
+    public synchronized void banIP(String s)
     {
         ipBans.add(s.toLowerCase());
         saveBannedList();
     }
 
-    public void pardonIP(String s)
+    public synchronized void pardonIP(String s)
     {
         ipBans.remove(s.toLowerCase());
         saveBannedList();
     }
 
-    private void loadBannedList()
+    private synchronized void loadBannedList()
     {
         try
         {
             ipBans.clear();
             BufferedReader bufferedreader = new BufferedReader(new FileReader(ipBansFile));
-            for (String s = ""; (s = bufferedreader.readLine()) != null; )
+            for (String ip; (ip = bufferedreader.readLine()) != null; )
             {
-                ipBans.add(s.trim().toLowerCase());
+                ipBans.add(ip.trim().toLowerCase());
             }
 
             bufferedreader.close();
@@ -414,15 +441,15 @@ public class PlayerList
         }
     }
 
-    private void saveBannedList()
+    private synchronized void saveBannedList()
     {
         try
         {
             PrintWriter printwriter = new PrintWriter(new FileWriter(ipBansFile, false));
-            String s;
-            for (Iterator iterator = ipBans.iterator(); iterator.hasNext(); printwriter.println(s))
+            String ip;
+            for (Iterator<String> iterator = ipBans.iterator(); iterator.hasNext(); printwriter.println(ip))
             {
-                s = (String) iterator.next();
+                ip = iterator.next();
             }
 
             printwriter.close();
@@ -433,27 +460,35 @@ public class PlayerList
         }
     }
 
-    public void opPlayer(String s)
+    public synchronized void opPlayer(UUID uuid)
     {
-        ops.add(s.toLowerCase());
+        ops.add(uuid);
         saveOps();
     }
 
-    public void deopPlayer(String s)
+    public synchronized void deopPlayer(UUID uuid)
     {
-        ops.remove(s.toLowerCase());
+        ops.remove(uuid);
         saveOps();
     }
 
-    private void loadOps()
+    private synchronized void loadOps()
     {
         try
         {
             ops.clear();
             BufferedReader bufferedreader = new BufferedReader(new FileReader(opsFile));
-            for (String s = ""; (s = bufferedreader.readLine()) != null; )
+            for (String entry; (entry = bufferedreader.readLine()) != null; )
             {
-                ops.add(s.trim().toLowerCase());
+                if (!UUIDHelper.isUUID(entry)) {
+                    awaitedLoadThreads.addAndGet(1);
+                    UUIDHelper.runConversionAction(entry, uuid -> {
+                        ops.add(uuid);
+                        awaitedLoadThreads.addAndGet(-1);
+                    }, (username) -> awaitedLoadThreads.addAndGet(-1));
+                } else {
+                    ops.add(UUID.fromString(entry));
+                }
             }
 
             bufferedreader.close();
@@ -464,15 +499,15 @@ public class PlayerList
         }
     }
 
-    private void saveOps()
+    private synchronized void saveOps()
     {
         try
         {
             PrintWriter printwriter = new PrintWriter(new FileWriter(opsFile, false));
-            String s;
-            for (Iterator iterator = ops.iterator(); iterator.hasNext(); printwriter.println(s))
+            UUID uuid;
+            for (Iterator<UUID> iterator = ops.iterator(); iterator.hasNext(); printwriter.println(uuid.toString()))
             {
-                s = (String) iterator.next();
+                uuid = iterator.next();
             }
 
             printwriter.close();
@@ -483,15 +518,23 @@ public class PlayerList
         }
     }
 
-    private void loadWhiteList()
+    private synchronized void loadWhiteList()
     {
         try
         {
             whitelist.clear();
             BufferedReader bufferedreader = new BufferedReader(new FileReader(whitelistFile));
-            for (String s = ""; (s = bufferedreader.readLine()) != null; )
+            for (String entry; (entry = bufferedreader.readLine()) != null; )
             {
-                whitelist.add(s.trim().toLowerCase());
+                if (!UUIDHelper.isUUID(entry)) {
+                    awaitedLoadThreads.addAndGet(1);
+                    UUIDHelper.runConversionAction(entry, uuid -> {
+                        whitelist.add(uuid);
+                        awaitedLoadThreads.addAndGet(-1);
+                    }, (username) -> awaitedLoadThreads.addAndGet(-1));
+                } else {
+                    whitelist.add(UUID.fromString(entry));
+                }
             }
 
             bufferedreader.close();
@@ -502,15 +545,15 @@ public class PlayerList
         }
     }
 
-    private void saveWhiteList()
+    private synchronized void saveWhiteList()
     {
         try
         {
             PrintWriter printwriter = new PrintWriter(new FileWriter(whitelistFile, false));
-            String s;
-            for (Iterator iterator = whitelist.iterator(); iterator.hasNext(); printwriter.println(s))
+            UUID uuid;
+            for (Iterator<UUID> iterator = whitelist.iterator(); iterator.hasNext(); printwriter.println(uuid.toString()))
             {
-                s = (String) iterator.next();
+                uuid = iterator.next();
             }
 
             printwriter.close();
@@ -521,25 +564,21 @@ public class PlayerList
         }
     }
 
-    public boolean isAllowedToLogin(String s)
+    public boolean isAllowedToLogin(UUID uuid)
     {
-        s = s.trim().toLowerCase();
-        return !whitelistEnforced || ops.contains(s) || whitelist.contains(s);
+        return !whitelistEnforced || ops.contains(uuid) || whitelist.contains(uuid);
     }
 
-    public boolean isOp(String s)
+    public boolean isOp(UUID uuid)
     {
-        return ops.contains(s.trim().toLowerCase());
+        return ops.contains(uuid);
     }
     @Nullable
     public ServerPlayer getPlayerEntity(String s)
     {
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            ServerPlayer entityplayermp = playerEntities.get(i);
-            if (entityplayermp.username.equalsIgnoreCase(s))
-            {
-                return entityplayermp;
+        for (ServerPlayer player : playerEntities) {
+            if (player.username.equalsIgnoreCase(s)) {
+                return player;
             }
         }
 
@@ -548,10 +587,10 @@ public class PlayerList
 
     public void sendChatMessageToPlayer(String s, String s1)
     {
-        ServerPlayer entityplayermp = getPlayerEntity(s);
-        if (entityplayermp != null)
+        ServerPlayer player = getPlayerEntity(s);
+        if (player != null)
         {
-            entityplayermp.playerNetServerHandler.sendPacket(new ChatPacket(s1));
+            player.playerNetServerHandler.sendPacket(new ChatPacket(s1));
         }
     }
 
@@ -580,12 +619,9 @@ public class PlayerList
     public void sendChatMessageToAllOps(String s)
     {
         ChatPacket chatPacket = new ChatPacket(s);
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            ServerPlayer entityplayermp = playerEntities.get(i);
-            if (isOp(entityplayermp.username))
-            {
-                entityplayermp.playerNetServerHandler.sendPacket(chatPacket);
+        for (ServerPlayer player : playerEntities) {
+            if (isOp(player.uuid)) {
+                player.playerNetServerHandler.sendPacket(chatPacket);
             }
         }
 
@@ -593,10 +629,10 @@ public class PlayerList
 
     public boolean sendPacketToPlayer(String s, Packet packet)
     {
-        ServerPlayer entityplayermp = getPlayerEntity(s);
-        if (entityplayermp != null)
+        ServerPlayer player = getPlayerEntity(s);
+        if (player != null)
         {
-            entityplayermp.playerNetServerHandler.sendPacket(packet);
+            player.playerNetServerHandler.sendPacket(packet);
             return true;
         }
         else
@@ -607,9 +643,8 @@ public class PlayerList
 
     public void savePlayerStates()
     {
-        for (int i = 0; i < playerEntities.size(); i++)
-        {
-            playerIo.save(playerEntities.get(i));
+        for (ServerPlayer playerEntity : playerEntities) {
+            playerIo.save(playerEntity);
         }
 
     }
@@ -618,19 +653,19 @@ public class PlayerList
     {
     }
 
-    public void addToWhiteList(String s)
+    public synchronized void addToWhiteList(UUID uuid)
     {
-        whitelist.add(s);
+        whitelist.add(uuid);
         saveWhiteList();
     }
 
-    public void removeFromWhiteList(String s)
+    public synchronized void removeFromWhiteList(UUID uuid)
     {
-        whitelist.remove(s);
+        whitelist.remove(uuid);
         saveWhiteList();
     }
 
-    public Set<String> getWhitelist()
+    public Set<UUID> getWhitelist()
     {
         return whitelist;
     }
